diff -up ./cmd/lib/secutil.c.mlkem ./cmd/lib/secutil.c
--- ./cmd/lib/secutil.c.mlkem	2024-10-18 11:20:24.025115522 -0700
+++ ./cmd/lib/secutil.c	2024-10-18 11:20:24.038115655 -0700
@@ -4182,7 +4182,8 @@ SECU_ParseSSLVersionRangeString(const ch
 static SSLNamedGroup
 groupNameToNamedGroup(char *name)
 {
-    if (PL_strlen(name) == 4) {
+    int len = PL_strlen(name);
+    if (len == 4) {
         if (!strncmp(name, "P256", 4)) {
             return ssl_grp_ec_secp256r1;
         }
@@ -4193,7 +4194,7 @@ groupNameToNamedGroup(char *name)
             return ssl_grp_ec_secp521r1;
         }
     }
-    if (PL_strlen(name) == 6) {
+    if (len == 6) {
         if (!strncmp(name, "x25519", 6)) {
             return ssl_grp_ec_curve25519;
         }
@@ -4213,9 +4214,14 @@ groupNameToNamedGroup(char *name)
             return ssl_grp_ffdhe_8192;
         }
     }
-    if (PL_strlen(name) == 11) {
-        if (!strncmp(name, "xyber768d00", 11)) {
-            return ssl_grp_kem_xyber768d00;
+    if (len == 14) {
+        if (!strncmp(name, "mlkem768x25519", 14)) {
+            return ssl_grp_kem_mlkem768x25519;
+        }
+    }
+    if (len== 17) {
+        if (!strncmp(name, "mlkem768secp256r1", 17)) {
+            return ssl_grp_kem_mlkem768secp256r1;
         }
     }
 
diff -up ./cmd/selfserv/selfserv.c.mlkem ./cmd/selfserv/selfserv.c
--- ./cmd/selfserv/selfserv.c.mlkem	2024-10-18 11:20:24.025115522 -0700
+++ ./cmd/selfserv/selfserv.c	2024-10-18 11:20:24.038115655 -0700
@@ -229,7 +229,7 @@ PrintParameterUsage()
         "-I comma separated list of enabled groups for TLS key exchange.\n"
         "   The following values are valid:\n"
         "   P256, P384, P521, x25519, FF2048, FF3072, FF4096, FF6144, FF8192,\n"
-        "   xyber768d00\n"
+        "   mlkem768x25519, mlkem768secp256r1\n"
         "-J comma separated list of enabled signature schemes in preference order.\n"
         "   The following values are valid:\n"
         "     rsa_pkcs1_sha1, rsa_pkcs1_sha256, rsa_pkcs1_sha384, rsa_pkcs1_sha512,\n"
diff -up ./cmd/tstclnt/tstclnt.c.mlkem ./cmd/tstclnt/tstclnt.c
--- ./cmd/tstclnt/tstclnt.c.mlkem	2024-10-18 11:20:24.026115533 -0700
+++ ./cmd/tstclnt/tstclnt.c	2024-10-18 11:20:24.039115665 -0700
@@ -307,7 +307,7 @@ PrintParameterUsage()
     fprintf(stderr, "%-20s Comma separated list of enabled groups for TLS key exchange.\n"
                     "%-20s The following values are valid:\n"
                     "%-20s P256, P384, P521, x25519, FF2048, FF3072, FF4096, FF6144, FF8192\n"
-                    "%-20s xyber768d00\n",
+                    "%-20s mlkem768x25519, mlkem768secp256r1\n",
             "-I", "", "", "");
     fprintf(stderr, "%-20s Comma separated list of signature schemes in preference order.\n"
                     "%-20s The following values are valid:\n"
diff -up ./gtests/nss_bogo_shim/nss_bogo_shim.cc.mlkem ./gtests/nss_bogo_shim/nss_bogo_shim.cc
--- ./gtests/nss_bogo_shim/nss_bogo_shim.cc.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./gtests/nss_bogo_shim/nss_bogo_shim.cc	2024-10-18 11:20:24.039115665 -0700
@@ -435,13 +435,6 @@ class TestAgent {
       if (rv != SECSuccess) {
         return false;
       }
-      // Xyber768 is disabled by policy by default, so if it's requested
-      // we need to update the policy flags as well.
-      for (auto group : groups) {
-        if (group == ssl_grp_kem_xyber768d00) {
-          NSS_SetAlgorithmPolicy(SEC_OID_XYBER768D00, NSS_USE_ALG_IN_SSL_KX, 0);
-        }
-      }
     }
 
     return true;
diff -up ./gtests/pk11_gtest/pk11_kem_unittest.cc.mlkem ./gtests/pk11_gtest/pk11_kem_unittest.cc
--- ./gtests/pk11_gtest/pk11_kem_unittest.cc.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./gtests/pk11_gtest/pk11_kem_unittest.cc	2024-10-18 11:20:24.039115665 -0700
@@ -13,7 +13,9 @@
 
 namespace nss_test {
 
-class Pkcs11KEMTest : public ::testing::Test {
+class Pkcs11KEMTest
+    : public ::testing::Test,
+      public ::testing::WithParamInterface<CK_NSS_KEM_PARAMETER_SET_TYPE> {
  protected:
   PK11SymKey *Encapsulate(const ScopedSECKEYPublicKey &pub,
                           CK_MECHANISM_TYPE target, PK11AttrFlags attrFlags,
@@ -65,22 +67,46 @@ class Pkcs11KEMTest : public ::testing::
 
     SECITEM_FreeItem(&attrValue, PR_FALSE);
   }
+
+  CK_MECHANISM_TYPE keyGenMech() {
+    switch (GetParam()) {
+      case CKP_NSS_KYBER_768_ROUND3:
+        return CKM_NSS_KYBER_KEY_PAIR_GEN;
+      case CKP_NSS_ML_KEM_768:
+        return CKM_NSS_ML_KEM_KEY_PAIR_GEN;
+      default:
+        EXPECT_TRUE(false);
+        return 0;
+    }
+  }
+
+  CK_MECHANISM_TYPE encapsMech() {
+    switch (GetParam()) {
+      case CKP_NSS_KYBER_768_ROUND3:
+        return CKM_NSS_KYBER;
+      case CKP_NSS_ML_KEM_768:
+        return CKM_NSS_ML_KEM;
+      default:
+        EXPECT_TRUE(false);
+        return 0;
+    }
+  }
 };
 
-TEST_F(Pkcs11KEMTest, KemConsistencyTest) {
-  Pkcs11KeyPairGenerator generator(CKM_NSS_KYBER_KEY_PAIR_GEN);
+TEST_P(Pkcs11KEMTest, KemConsistencyTest) {
+  Pkcs11KeyPairGenerator generator(keyGenMech());
   ScopedSECKEYPrivateKey priv;
   ScopedSECKEYPublicKey pub;
   generator.GenerateKey(&priv, &pub, false);
 
-  ASSERT_EQ((unsigned int)KYBER768_PUBLIC_KEY_BYTES,
-            (unsigned int)pub->u.kyber.publicValue.len);
+  ASSERT_NE(nullptr, pub);
+  ASSERT_NE(nullptr, priv);
 
   // Copy the public key to simulate receiving the key as an octet string
   ScopedSECKEYPublicKey pubCopy(SECKEY_CopyPublicKey(pub.get()));
   ASSERT_NE(nullptr, pubCopy);
 
-  ScopedPK11SlotInfo slot(PK11_GetBestSlot(CKM_NSS_KYBER, nullptr));
+  ScopedPK11SlotInfo slot(PK11_GetBestSlot(encapsMech(), nullptr));
   ASSERT_NE(nullptr, slot);
 
   ASSERT_NE((unsigned int)CK_INVALID_HANDLE,
@@ -91,9 +117,6 @@ TEST_F(Pkcs11KEMTest, KemConsistencyTest
       pubCopy, CKM_SALSA20_POLY1305, PK11_ATTR_PRIVATE | PK11_ATTR_UNMODIFIABLE,
       CKF_ENCRYPT, &ciphertext));
 
-  ASSERT_EQ((unsigned int)KYBER768_CIPHERTEXT_BYTES,
-            (unsigned int)ciphertext->len);
-
   ASSERT_EQ(CKM_SALSA20_POLY1305, PK11_GetMechanism(sharedSecret.get()));
 
   CK_BBOOL ckTrue = CK_TRUE;
@@ -119,4 +142,7 @@ TEST_F(Pkcs11KEMTest, KemConsistencyTest
   EXPECT_EQ(0, SECITEM_CompareItem(item1, item2));
 }
 
+INSTANTIATE_TEST_SUITE_P(Pkcs11KEMTest, Pkcs11KEMTest,
+                         ::testing::Values(CKP_NSS_ML_KEM_768));
+
 }  // namespace nss_test
diff -up ./gtests/pk11_gtest/pk11_keygen.cc.mlkem ./gtests/pk11_gtest/pk11_keygen.cc
--- ./gtests/pk11_gtest/pk11_keygen.cc.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./gtests/pk11_gtest/pk11_keygen.cc	2024-10-18 11:20:24.039115665 -0700
@@ -158,6 +158,11 @@ std::unique_ptr<ParamHolder> Pkcs11KeyPa
       return std::unique_ptr<ParamHolder>(
           new KyberParamHolder(CKP_NSS_KYBER_768_ROUND3));
 
+    case CKM_NSS_ML_KEM_KEY_PAIR_GEN:
+      std::cerr << "Generate ML-KEM768 pair" << std::endl;
+      return std::unique_ptr<ParamHolder>(
+          new KyberParamHolder(CKP_NSS_ML_KEM_768));
+
     default:
       ADD_FAILURE() << "unknown OID " << mech_;
   }
diff -up ./gtests/ssl_gtest/manifest.mn.mlkem ./gtests/ssl_gtest/manifest.mn
--- ./gtests/ssl_gtest/manifest.mn.mlkem	2024-10-18 11:20:24.000115267 -0700
+++ ./gtests/ssl_gtest/manifest.mn	2024-10-18 11:20:24.039115665 -0700
@@ -13,6 +13,7 @@ CSRCS = \
 
 CPPSRCS = \
       bloomfilter_unittest.cc \
+      selfencrypt_unittest.cc \
       ssl_0rtt_unittest.cc \
       ssl_aead_unittest.cc \
       ssl_agent_unittest.cc \
@@ -42,24 +43,23 @@ CPPSRCS = \
       ssl_record_unittest.cc \
       ssl_recordsep_unittest.cc \
       ssl_recordsize_unittest.cc \
-      ssl_resumption_unittest.cc \
       ssl_renegotiation_unittest.cc \
+      ssl_resumption_unittest.cc \
       ssl_skip_unittest.cc \
       ssl_staticrsa_unittest.cc \
       ssl_tls13compat_unittest.cc \
       ssl_v2_client_hello_unittest.cc \
       ssl_version_unittest.cc \
       ssl_versionpolicy_unittest.cc \
-      selfencrypt_unittest.cc \
       test_io.cc \
       tls_agent.cc \
       tls_connect.cc \
-      tls_hkdf_unittest.cc \
       tls_filter.cc \
+      tls_hkdf_unittest.cc \
+      tls_mlkem_unittest.cc \
       tls_protect.cc \
       tls_psk_unittest.cc \
       tls_subcerts_unittest.cc \
-      tls_xyber_unittest.cc \
       $(SSLKEYLOGFILE_FILES) \
       $(NULL)
 
diff -up ./gtests/ssl_gtest/ssl_gtest.gyp.mlkem ./gtests/ssl_gtest/ssl_gtest.gyp
--- ./gtests/ssl_gtest/ssl_gtest.gyp.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./gtests/ssl_gtest/ssl_gtest.gyp	2024-10-18 11:20:24.039115665 -0700
@@ -31,8 +31,8 @@
         'ssl_ems_unittest.cc',
         'ssl_exporter_unittest.cc',
         'ssl_extension_unittest.cc',
-        'ssl_fuzz_unittest.cc',
         'ssl_fragment_unittest.cc',
+        'ssl_fuzz_unittest.cc',
         'ssl_gather_unittest.cc',
         'ssl_gtest.cc',
         'ssl_hrr_unittest.cc',
@@ -43,8 +43,8 @@
         'ssl_record_unittest.cc',
         'ssl_recordsep_unittest.cc',
         'ssl_recordsize_unittest.cc',
-        'ssl_resumption_unittest.cc',
         'ssl_renegotiation_unittest.cc',
+        'ssl_resumption_unittest.cc',
         'ssl_skip_unittest.cc',
         'ssl_staticrsa_unittest.cc',
         'ssl_tls13compat_unittest.cc',
@@ -54,13 +54,14 @@
         'test_io.cc',
         'tls_agent.cc',
         'tls_connect.cc',
+        'tls_ech_unittest.cc',
         'tls_filter.cc',
+        'tls_grease_unittest.cc',
         'tls_hkdf_unittest.cc',
-        'tls_ech_unittest.cc',
+        'tls_mlkem_unittest.cc',
         'tls_protect.cc',
         'tls_psk_unittest.cc',
         'tls_subcerts_unittest.cc',
-        'tls_grease_unittest.cc',
         'tls_xyber_unittest.cc',
       ],
       'dependencies': [
diff -up ./gtests/ssl_gtest/tls_agent.cc.mlkem ./gtests/ssl_gtest/tls_agent.cc
--- ./gtests/ssl_gtest/tls_agent.cc.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./gtests/ssl_gtest/tls_agent.cc	2024-10-18 11:20:24.039115665 -0700
@@ -493,15 +493,15 @@ void TlsAgent::DisableAllCiphers() {
 // Not actually all groups, just the ones that we are actually willing
 // to use.
 const std::vector<SSLNamedGroup> kAllDHEGroups = {
-    ssl_grp_ec_curve25519,   ssl_grp_ec_secp256r1, ssl_grp_ec_secp384r1,
-    ssl_grp_ec_secp521r1,    ssl_grp_ffdhe_2048,   ssl_grp_ffdhe_3072,
-    ssl_grp_ffdhe_4096,      ssl_grp_ffdhe_6144,   ssl_grp_ffdhe_8192,
-    ssl_grp_kem_xyber768d00,
+    ssl_grp_ec_curve25519,   ssl_grp_ec_secp256r1,       ssl_grp_ec_secp384r1,
+    ssl_grp_ec_secp521r1,    ssl_grp_ffdhe_2048,         ssl_grp_ffdhe_3072,
+    ssl_grp_ffdhe_4096,      ssl_grp_ffdhe_6144,         ssl_grp_ffdhe_8192,
+    ssl_grp_kem_mlkem768x25519, ssl_grp_kem_mlkem768secp256r1,
 };
 
 const std::vector<SSLNamedGroup> kECDHEGroups = {
     ssl_grp_ec_curve25519, ssl_grp_ec_secp256r1,    ssl_grp_ec_secp384r1,
-    ssl_grp_ec_secp521r1,  ssl_grp_kem_xyber768d00,
+    ssl_grp_ec_secp521r1,  ssl_grp_kem_mlkem768x25519, ssl_grp_kem_mlkem768secp256r1,
 };
 
 const std::vector<SSLNamedGroup> kFFDHEGroups = {
@@ -510,12 +510,14 @@ const std::vector<SSLNamedGroup> kFFDHEG
 
 // Defined because the big DHE groups are ridiculously slow.
 const std::vector<SSLNamedGroup> kFasterDHEGroups = {
-    ssl_grp_ec_curve25519, ssl_grp_ec_secp256r1, ssl_grp_ec_secp384r1,
-    ssl_grp_ffdhe_2048,    ssl_grp_ffdhe_3072,   ssl_grp_kem_xyber768d00,
+    ssl_grp_ec_curve25519,      ssl_grp_ec_secp256r1, ssl_grp_ec_secp384r1,
+    ssl_grp_ffdhe_2048,         ssl_grp_ffdhe_3072, 
+    ssl_grp_kem_mlkem768x25519, ssl_grp_kem_mlkem768secp256r1,
 };
 
 const std::vector<SSLNamedGroup> kEcdhHybridGroups = {
-    ssl_grp_kem_xyber768d00,
+    ssl_grp_kem_mlkem768x25519,
+    ssl_grp_kem_mlkem768secp256r1,
 };
 
 void TlsAgent::EnableCiphersByKeyExchange(SSLKEAType kea) {
@@ -683,9 +685,10 @@ void TlsAgent::CheckKEA(SSLKEAType kea,
   if (kea_size == 0) {
     switch (kea_group) {
       case ssl_grp_ec_curve25519:
-      case ssl_grp_kem_xyber768d00:
+      case ssl_grp_kem_mlkem768x25519:
         kea_size = 255;
         break;
+      case ssl_grp_kem_mlkem768secp256r1:
       case ssl_grp_ec_secp256r1:
         kea_size = 256;
         break;
diff -up ./gtests/ssl_gtest/tls_mlkem_unittest.cc.mlkem ./gtests/ssl_gtest/tls_mlkem_unittest.cc
--- ./gtests/ssl_gtest/tls_mlkem_unittest.cc.mlkem	2024-10-18 11:20:24.039115665 -0700
+++ ./gtests/ssl_gtest/tls_mlkem_unittest.cc	2024-10-18 12:00:26.097690267 -0700
@@ -0,0 +1,516 @@
+/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
+/* vim: set ts=2 et sw=2 tw=80: */
+/* This Source Code Form is subject to the terms of the Mozilla Public
+ * License, v. 2.0. If a copy of the MPL was not distributed with this file,
+ * You can obtain one at http://mozilla.org/MPL/2.0/. */
+
+#include "ssl.h"
+#include "sslerr.h"
+#include "sslproto.h"
+#include "secmodti.h"  /* for SEC_OID_MLKEM768SECP256R1, remove when shipped upstream */
+
+extern "C" {
+// This is not something that should make you happy.
+#include "libssl_internals.h"
+}
+
+#include "gtest_utils.h"
+#include "nss_scoped_ptrs.h"
+#include "tls_connect.h"
+#include "tls_filter.h"
+#include "tls_parser.h"
+
+namespace nss_test {
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768x25519Supported) {
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_kem_mlkem768x25519});
+
+  Connect();
+  CheckKeys(ssl_kea_ecdh_hybrid, ssl_grp_kem_mlkem768x25519, ssl_auth_rsa_sign,
+            ssl_sig_rsa_pss_rsae_sha256);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768Secp256r1Supported) {
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_kem_mlkem768secp256r1});
+
+  Connect();
+  CheckKeys(ssl_kea_ecdh_hybrid, ssl_grp_kem_mlkem768secp256r1,
+            ssl_auth_rsa_sign, ssl_sig_rsa_pss_rsae_sha256);
+}
+
+TEST_P(TlsKeyExchangeTest, Tls12ClientMlkem768StartNotSupported) {
+  EnsureKeyShareSetup();
+  client_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_2);
+  server_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_3);
+  client_->DisableAllCiphers();
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh);
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh_hybrid);
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(
+                            client_->ssl_fd(),
+                            kECDHEGroups.size() + kEcdhHybridGroups.size()));
+
+  Connect();
+  std::vector<SSLNamedGroup> groups = GetGroupDetails(groups_capture_);
+  for (auto group : groups) {
+    EXPECT_NE(group, ssl_grp_kem_mlkem768x25519);
+    EXPECT_NE(group, ssl_grp_kem_mlkem768secp256r1);
+  }
+}
+
+TEST_P(TlsKeyExchangeTest13, Tls12ServerMlkem768x25519NotSupported) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+
+  EnsureKeyShareSetup();
+
+  client_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_3);
+  server_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_2);
+
+  client_->DisableAllCiphers();
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh);
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh_hybrid);
+  client_->ConfigNamedGroups(
+      {ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  server_->EnableCiphersByKeyExchange(ssl_kea_ecdh);
+  server_->EnableCiphersByKeyExchange(ssl_kea_ecdh_hybrid);
+  server_->ConfigNamedGroups(
+      {ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519});
+
+  Connect();
+  CheckKeys(ssl_kea_ecdh, ssl_grp_ec_curve25519, ssl_auth_rsa_sign,
+            ssl_sig_rsa_pss_rsae_sha256);
+}
+
+TEST_P(TlsKeyExchangeTest13, Tls12ServerMlkem768Secp256r1NotSupported) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+
+  EnsureKeyShareSetup();
+
+  client_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_3);
+  server_->SetVersionRange(SSL_LIBRARY_VERSION_TLS_1_2,
+                           SSL_LIBRARY_VERSION_TLS_1_2);
+
+  client_->DisableAllCiphers();
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh);
+  client_->EnableCiphersByKeyExchange(ssl_kea_ecdh_hybrid);
+  client_->ConfigNamedGroups(
+      {ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  server_->EnableCiphersByKeyExchange(ssl_kea_ecdh);
+  server_->EnableCiphersByKeyExchange(ssl_kea_ecdh_hybrid);
+  server_->ConfigNamedGroups(
+      {ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+
+  Connect();
+  CheckKeys(ssl_kea_ecdh, ssl_grp_ec_secp256r1, ssl_auth_rsa_sign,
+            ssl_sig_rsa_pss_rsae_sha256);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768x25519ClientDisabledByPolicy) {
+  EnsureKeyShareSetup();
+  client_->SetPolicy(SEC_OID_MLKEM768X25519, 0, NSS_USE_ALG_IN_SSL_KX);
+  ConfigNamedGroups({ssl_grp_kem_mlkem768x25519, ssl_grp_ec_secp256r1});
+
+  Connect();
+  CheckKEXDetails({ssl_grp_ec_secp256r1}, {ssl_grp_ec_secp256r1});
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768x25519ServerDisabledByPolicy) {
+  EnsureKeyShareSetup();
+  server_->SetPolicy(SEC_OID_MLKEM768X25519, 0, NSS_USE_ALG_IN_SSL_KX);
+  ConfigNamedGroups({ssl_grp_kem_mlkem768x25519, ssl_grp_ec_secp256r1});
+
+  Connect();
+  CheckKEXDetails({ssl_grp_kem_mlkem768x25519, ssl_grp_ec_secp256r1},
+                  {ssl_grp_kem_mlkem768x25519}, ssl_grp_ec_secp256r1);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768Secp256r1ClientDisabledByPolicy) {
+  EnsureKeyShareSetup();
+  client_->SetPolicy(SEC_OID_MLKEM768SECP256R1, 0, NSS_USE_ALG_IN_SSL_KX);
+  ConfigNamedGroups({ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+
+  Connect();
+  CheckKEXDetails({ssl_grp_ec_secp256r1}, {ssl_grp_ec_secp256r1});
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768Secp256r1ServerDisabledByPolicy) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+  EnsureKeyShareSetup();
+  server_->SetPolicy(SEC_OID_MLKEM768SECP256R1, 0, NSS_USE_ALG_IN_SSL_KX);
+  ConfigNamedGroups({ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+
+  Connect();
+  CheckKEXDetails({ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1},
+                  {ssl_grp_kem_mlkem768secp256r1}, ssl_grp_ec_secp256r1);
+}
+
+static void CheckECDHShareReuse(
+    const std::shared_ptr<TlsExtensionCapture>& capture) {
+  EXPECT_TRUE(capture->captured());
+  const DataBuffer& ext = capture->extension();
+  DataBuffer hybrid_share[4];
+  DataBuffer ecdh_share[4];
+  int hybrid_offset[4];
+  SSLNamedGroup hybrid_ec_type[4];
+  SSLNamedGroup ec_type[4];
+  int ecdh_index[4];
+  int nextHybrid = 0;
+  int nextECDH = 0;
+
+  size_t offset = 0;
+  uint32_t ext_len;
+  ext.Read(0, 2, &ext_len);
+  EXPECT_EQ(ext.len() - 2, ext_len);
+  offset += 2;
+
+  uint32_t named_group;
+  uint32_t named_group_len;
+  ext.Read(offset, 2, &named_group);
+  ext.Read(offset + 2, 2, &named_group_len);
+  while (offset < ext.len()) {
+    switch (named_group) {
+    case ssl_grp_kem_mlkem768x25519:
+      hybrid_share[nextHybrid] = DataBuffer(ext.data() + offset + 2 + 2, named_group_len);
+      hybrid_offset[nextHybrid] = KYBER768_PUBLIC_KEY_BYTES;
+      hybrid_ec_type[nextHybrid] = ssl_grp_ec_curve25519;
+      nextHybrid++;
+      break;
+    case ssl_grp_kem_mlkem768secp256r1:
+      hybrid_share[nextHybrid] = DataBuffer(ext.data() + offset + 2 + 2, named_group_len);
+      hybrid_offset[nextHybrid] = 0;
+      hybrid_ec_type[nextHybrid] = ssl_grp_ec_secp256r1;
+      nextHybrid++;
+    case ssl_grp_ec_curve25519:
+    case ssl_grp_ec_secp256r1:
+      ecdh_share[nextECDH] = DataBuffer(ext.data() + offset + 2 + 2, named_group_len);
+      ec_type[nextECDH] = (SSLNamedGroup) named_group;
+      nextECDH++;
+    }
+    offset += 2 + 2 + named_group_len;
+    ext.Read(offset, 2, &named_group);
+    ext.Read(offset + 2, 2, &named_group_len);
+  }
+  EXPECT_EQ(offset, ext.len());
+
+  ASSERT_TRUE(nextECDH > 0);
+  ASSERT_TRUE(nextHybrid > 0);
+  /* setup the hybrid ecdh indeces */
+  for (int i=0; i < nextHybrid; i++) {
+    ecdh_index[i] = -1;
+    for (int j=0; j < nextECDH; j++) {
+      if (hybrid_ec_type[i] == ec_type[j]) {
+        ecdh_index[i] = j;
+        break;
+      }
+    }
+    ASSERT_TRUE(ecdh_index[i] != -1);
+  }
+  for (int i=0; i < nextECDH; i++) {
+      ASSERT_TRUE(ecdh_share[i].data());
+  }
+  for (int i=0; i < nextHybrid; i++) {
+      int j = ecdh_index[i];
+      ASSERT_TRUE(hybrid_share[i].data());
+      ASSERT_GT(hybrid_share[i].len(), ecdh_share[j].len());
+      EXPECT_EQ(0, memcmp(hybrid_share[i].data() + hybrid_offset[i],
+                   ecdh_share[j].data(), ecdh_share[j].len()));
+  }
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768x25519ShareReuseFirst) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  Connect();
+
+  CheckKEXDetails({ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519},
+                  {ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519});
+  CheckECDHShareReuse(shares_capture_);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768x25519ShareReuseSecond) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_ec_curve25519, ssl_grp_kem_mlkem768x25519});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  Connect();
+
+  CheckKEXDetails({ssl_grp_ec_curve25519, ssl_grp_kem_mlkem768x25519},
+                  {ssl_grp_ec_curve25519, ssl_grp_kem_mlkem768x25519});
+  CheckECDHShareReuse(shares_capture_);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768Secp256r1ShareReuseFirst) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  Connect();
+
+  CheckKEXDetails({ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1},
+                  {ssl_grp_kem_mlkem768secp256r1, ssl_grp_ec_secp256r1});
+  CheckECDHShareReuse(shares_capture_);
+}
+
+TEST_P(TlsKeyExchangeTest13, Mlkem768Secp256r1ShareReuseSecond) {
+  if (variant_ == ssl_variant_datagram) {
+    /* Bug 1874451 - reenable this test */
+    return;
+  }
+  EnsureKeyShareSetup();
+  ConfigNamedGroups({ssl_grp_ec_secp256r1, ssl_grp_kem_mlkem768secp256r1});
+  EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+
+  Connect();
+
+  CheckKEXDetails({ssl_grp_ec_secp256r1, ssl_grp_kem_mlkem768secp256r1},
+                  {ssl_grp_ec_secp256r1, ssl_grp_kem_mlkem768secp256r1});
+  CheckECDHShareReuse(shares_capture_);
+}
+
+class Mlkem768x25519ShareDamager : public TlsExtensionFilter {
+ public:
+  typedef enum {
+    downgrade,
+    extend,
+    truncate,
+    zero_ecdh,
+    modify_ecdh,
+    modify_mlkem,
+    modify_mlkem_pubkey_mod_q,
+  } damage_type;
+
+  Mlkem768x25519ShareDamager(const std::shared_ptr<TlsAgent>& a,
+                             damage_type damage)
+      : TlsExtensionFilter(a), damage_(damage) {}
+
+  virtual PacketFilter::Action FilterExtension(uint16_t extension_type,
+                                               const DataBuffer& input,
+                                               DataBuffer* output) {
+    if (extension_type != ssl_tls13_key_share_xtn) {
+      return KEEP;
+    }
+
+    // Find the Mlkem768x25519 share
+    size_t offset = 0;
+    if (agent()->role() == TlsAgent::CLIENT) {
+      offset += 2;  // skip KeyShareClientHello length
+    }
+
+    uint32_t named_group;
+    uint32_t named_group_len;
+    input.Read(offset, 2, &named_group);
+    input.Read(offset + 2, 2, &named_group_len);
+    while (named_group != ssl_grp_kem_mlkem768x25519) {
+      offset += 2 + 2 + named_group_len;
+      input.Read(offset, 2, &named_group);
+      input.Read(offset + 2, 2, &named_group_len);
+    }
+    EXPECT_EQ(named_group, ssl_grp_kem_mlkem768x25519);
+
+    DataBuffer hybrid_key_share(input.data() + offset, 2 + 2 + named_group_len);
+
+    // Damage the Mlkem768x25519 share
+    uint32_t mlkem_component_len =
+        hybrid_key_share.len() - 2 - 2 - X25519_PUBLIC_KEY_BYTES;
+    unsigned char* ecdh_component =
+        hybrid_key_share.data() + 2 + 2 + mlkem_component_len;
+    unsigned char* mlkem_component = hybrid_key_share.data() + 2 + 2;
+    switch (damage_) {
+      case Mlkem768x25519ShareDamager::downgrade:
+        // Downgrade a Mlkem768x25519 share to X25519
+        memcpy(mlkem_component, ecdh_component, X25519_PUBLIC_KEY_BYTES);
+        hybrid_key_share.Truncate(2 + 2 + X25519_PUBLIC_KEY_BYTES);
+        hybrid_key_share.Write(0, ssl_grp_ec_curve25519, 2);
+        hybrid_key_share.Write(2, X25519_PUBLIC_KEY_BYTES, 2);
+        break;
+      case Mlkem768x25519ShareDamager::truncate:
+        // Truncate a Mlkem768x25519 share before the X25519 component
+        hybrid_key_share.Truncate(2 + 2 + mlkem_component_len);
+        hybrid_key_share.Write(2, mlkem_component_len, 2);
+        break;
+      case Mlkem768x25519ShareDamager::extend:
+        // Append 4 bytes to a Mlkem768x25519 share
+        uint32_t current_len;
+        hybrid_key_share.Read(2, 2, &current_len);
+        hybrid_key_share.Write(hybrid_key_share.len(), current_len, 4);
+        hybrid_key_share.Write(2, current_len + 4, 2);
+        break;
+      case Mlkem768x25519ShareDamager::zero_ecdh:
+        // Replace an X25519 component with 0s
+        memset(ecdh_component, 0, X25519_PUBLIC_KEY_BYTES);
+        break;
+      case Mlkem768x25519ShareDamager::modify_ecdh:
+        // Flip a bit in the X25519 component
+        ecdh_component[0] ^= 0x01;
+        break;
+      case Mlkem768x25519ShareDamager::modify_mlkem:
+        // Flip a bit in the mlkem component
+        mlkem_component[0] ^= 0x01;
+        break;
+      case Mlkem768x25519ShareDamager::modify_mlkem_pubkey_mod_q:
+        if (agent()->role() == TlsAgent::CLIENT) {
+          // Replace the client's public key with an sequence of 12-bit values
+          // in the same equivalence class mod 3329. The FIPS-203 input
+          // validation check should fail.
+          for (size_t i = 0; i < mlkem_component_len - 32; i += 3) {
+            // Pairs of 12-bit coefficients are packed into 3 bytes.
+            // Unpack them, change equivalence class if possible, and repack.
+            uint16_t coeff0 =
+                mlkem_component[i] | ((mlkem_component[i + 1] & 0x0f) << 8);
+            uint16_t coeff1 = (mlkem_component[i + 1] & 0xf0 >> 4) |
+                              ((mlkem_component[i + 2]) << 4);
+            if (coeff0 < 4096 - 3329) {
+              coeff0 += 3329;
+            }
+            if (coeff1 < 4096 - 3329) {
+              coeff1 += 3329;
+            }
+            mlkem_component[i] = coeff0;
+            mlkem_component[i + 1] = (coeff0 >> 8) + ((coeff1 & 0x0f) << 4);
+            mlkem_component[i + 2] = coeff1 >> 4;
+          }
+        }
+        break;
+    }
+
+    *output = input;
+    output->Splice(hybrid_key_share, offset, 2 + 2 + named_group_len);
+
+    // Fix the KeyShareClientHello length if necessary
+    if (agent()->role() == TlsAgent::CLIENT &&
+        hybrid_key_share.len() != 2 + 2 + named_group_len) {
+      output->Write(0, output->len() - 2, 2);
+    }
+
+    return CHANGE;
+  }
+
+ private:
+  damage_type damage_;
+};
+
+class TlsMlkem768x25519DamageTest
+    : public TlsConnectTestBase,
+      public ::testing::WithParamInterface<
+          Mlkem768x25519ShareDamager::damage_type> {
+ public:
+  TlsMlkem768x25519DamageTest()
+      : TlsConnectTestBase(ssl_variant_stream, SSL_LIBRARY_VERSION_TLS_1_3) {}
+
+ protected:
+  void Damage(const std::shared_ptr<TlsAgent>& agent) {
+    EnsureTlsSetup();
+    client_->ConfigNamedGroups(
+        {ssl_grp_ec_curve25519, ssl_grp_kem_mlkem768x25519});
+    server_->ConfigNamedGroups(
+        {ssl_grp_kem_mlkem768x25519, ssl_grp_ec_curve25519});
+    EXPECT_EQ(SECSuccess, SSL_SendAdditionalKeyShares(client_->ssl_fd(), 1));
+    MakeTlsFilter<Mlkem768x25519ShareDamager>(agent, GetParam());
+  }
+};
+
+TEST_P(TlsMlkem768x25519DamageTest, DamageClientShare) {
+  Damage(client_);
+
+  switch (GetParam()) {
+    case Mlkem768x25519ShareDamager::extend:
+    case Mlkem768x25519ShareDamager::truncate:
+      ConnectExpectAlert(server_, kTlsAlertIllegalParameter);
+      server_->CheckErrorCode(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
+      break;
+    case Mlkem768x25519ShareDamager::zero_ecdh:
+      ConnectExpectAlert(server_, kTlsAlertIllegalParameter);
+      server_->CheckErrorCode(SEC_ERROR_INVALID_KEY);
+      break;
+    case Mlkem768x25519ShareDamager::modify_mlkem_pubkey_mod_q:
+      ConnectExpectAlert(server_, kTlsAlertIllegalParameter);
+      server_->CheckErrorCode(SEC_ERROR_INVALID_ARGS);
+      break;
+    case Mlkem768x25519ShareDamager::downgrade:
+    case Mlkem768x25519ShareDamager::modify_ecdh:
+    case Mlkem768x25519ShareDamager::modify_mlkem:
+      client_->ExpectSendAlert(kTlsAlertBadRecordMac);
+      server_->ExpectSendAlert(kTlsAlertBadRecordMac);
+      ConnectExpectFail();
+      client_->CheckErrorCode(SSL_ERROR_BAD_MAC_READ);
+      server_->CheckErrorCode(SSL_ERROR_BAD_MAC_READ);
+      break;
+  }
+}
+
+TEST_P(TlsMlkem768x25519DamageTest, DamageServerShare) {
+  Damage(server_);
+
+  switch (GetParam()) {
+    case Mlkem768x25519ShareDamager::extend:
+    case Mlkem768x25519ShareDamager::truncate:
+      client_->ExpectSendAlert(kTlsAlertIllegalParameter);
+      server_->ExpectSendAlert(kTlsAlertUnexpectedMessage);
+      ConnectExpectFail();
+      client_->CheckErrorCode(SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE);
+      break;
+    case Mlkem768x25519ShareDamager::zero_ecdh:
+      client_->ExpectSendAlert(kTlsAlertIllegalParameter);
+      server_->ExpectSendAlert(kTlsAlertUnexpectedMessage);
+      ConnectExpectFail();
+      client_->CheckErrorCode(SEC_ERROR_INVALID_KEY);
+      break;
+    case Mlkem768x25519ShareDamager::downgrade:
+    case Mlkem768x25519ShareDamager::modify_ecdh:
+    case Mlkem768x25519ShareDamager::modify_mlkem:
+      client_->ExpectSendAlert(kTlsAlertBadRecordMac);
+      server_->ExpectSendAlert(kTlsAlertBadRecordMac);
+      ConnectExpectFail();
+      client_->CheckErrorCode(SSL_ERROR_BAD_MAC_READ);
+      server_->CheckErrorCode(SSL_ERROR_BAD_MAC_READ);
+      break;
+    case Mlkem768x25519ShareDamager::modify_mlkem_pubkey_mod_q:
+      // The server doesn't send a public key, so nothing is changed.
+      break;
+  }
+}
+
+INSTANTIATE_TEST_SUITE_P(
+    TlsMlkem768x25519DamageTest, TlsMlkem768x25519DamageTest,
+    ::testing::Values(Mlkem768x25519ShareDamager::downgrade,
+                      Mlkem768x25519ShareDamager::extend,
+                      Mlkem768x25519ShareDamager::truncate,
+                      Mlkem768x25519ShareDamager::zero_ecdh,
+                      Mlkem768x25519ShareDamager::modify_ecdh,
+                      Mlkem768x25519ShareDamager::modify_mlkem,
+                      Mlkem768x25519ShareDamager::modify_mlkem_pubkey_mod_q));
+
+}  // namespace nss_test
